%define anolis_release 4

%global __requires_exclude %{?__requires_exclude:%{__requires_exclude}|}^perl\\(RPC::\\)

%bcond_with perl_DBI_enables_Clone
%bcond_with perl_DBI_enables_DB_File
%bcond_with perl_DBI_enables_MLDBM
%bcond_with perl_DBI_enables_optional_test

Name:           perl-DBI
Version:        1.643
Release:        %{anolis_release}%{?dist}
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
Summary:        A database access API for perl
URL:            http://dbi.perl.org/
Source0:        https://cpan.metacpan.org/authors/id/T/TI/TIMB/DBI-%{version}.tar.gz

BuildRequires:  gcc findutils coreutils make glibc-common sed
BuildRequires:  perl-interpreter perl-generators perl-devel
BuildRequires:  perl(File::Find) perl(strict) perl(ExtUtils::MakeMaker) >= 6.76
# Run-time:
BuildRequires:  perl(Cwd) perl(Config) perl(base) perl(constant) perl(Carp)

BuildRequires:  perl(Exporter) perl(Errno) perl(DynaLoader) perl(Data::Dumper)
BuildRequires:  perl(File::Basename) perl(File::Spec) perl(FileHandle) perl(Fcntl)
BuildRequires:  perl(IPC::Open3) perl(Math::BigInt) perl(Scalar::Util) perl(Storable)
BuildRequires:  perl(IO::File) perl(IO::Select) perl(Getopt::Long) perl(IO::Dir)
BuildRequires:  perl(warnings) perl(utf8) perl(vars)
BuildRequires:  perl(UNIVERSAL) perl(Tie::Hash) perl(threads) perl(Symbol)
# Optional run-time:
%if %{with perl_DBI_enables_Clone}
BuildRequires:  perl(Clone) >= 0.34
%endif
%if %{with perl_DBI_enables_DB_File}
BuildRequires:  perl(DB_File)
%endif
%if %{with perl_DBI_enables_MLDBM}
BuildRequires:  perl(MLDBM)
%endif
# Tests
BuildRequires:  perl(lib) perl(File::Copy) perl(File::Path)
BuildRequires:  perl(Test::More) perl(overload) perl(Test::Simple) >= 0.90
BuildRequires:  perl(Benchmark) perl(Encode) perl(B) perl(blib)
%if %{with perl_DBI_enables_optional_test}
# Optional tests
BuildRequires:  perl(Test::Pod) >= 1.00 perl(Test::Pod::Coverage) >= 1.04
%endif
%if %{with perl_DBI_enables_Clone}
Suggests:       perl(Clone) >= 0.34
%endif
%if %{with perl_DBI_enables_DB_File}
Suggests:       perl(DB_File)
%endif
Requires:       perl(FileHandle) perl(Math::BigInt) 
%if %{with perl_DBI_enables_MLDBM}
Suggests:       perl(MLDBM)
%endif

# Filter unwanted dependencies
%{?perl_default_filter}

%description 
The DBI module enables your Perl applications to access multiple database types transparently. 
You can connect to PostgreSQL, SQLite, MySQL, MSSQL, Oracle, Informix, Sybase, ODBC and many 
more without having to know the different underlying interfaces of each. The API defined by 
DBI will work on all these database types and many more.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n DBI-%{version} 
for F in lib/DBD/Gofer.pm; do
    iconv -f ISO-8859-1 -t UTF-8 < "$F" > "${F}.utf8"
    touch -r "$F" "${F}.utf8"
    mv "${F}.utf8" "$F"
done
# Fix shell bangs
for F in dbixs_rev.pl ex/corogofer.pl; do
    perl -MExtUtils::MakeMaker -e "ExtUtils::MM_Unix->fixin(q{$F})"
done
chmod 0644 ex/*
chmod 0755 dbixs_rev.pl
rm lib/DBD/Gofer/Transport/corostream.pm
sed -i -e '/^lib\/DBD\/Gofer\/Transport\/corostream.pm$/d' MANIFEST
# Remove RPC::Pl* reverse dependencies due to security concerns,
# CVE-2013-7284, bug #1051110
for F in lib/Bundle/DBI.pm lib/DBD/Proxy.pm lib/DBI/ProxyServer.pm \
        dbiproxy.PL t/80proxy.t; do
    rm "$F"
    sed -i -e '\|^'"$F"'|d' MANIFEST
done
sed -i -e 's/"dbiproxy$ext_pl",//' Makefile.PL
# Remove Win32 specific files to avoid unwanted dependencies
for F in lib/DBI/W32ODBC.pm lib/Win32/DBIODBC.pm; do
    rm "$F"
    sed -i -e '\|^'"$F"'|d' MANIFEST
done

%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}" \
  NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}

%install
%{make_install}
find %{buildroot} -type f -name '*.bs' -empty -delete
%{_fixperms} '%{buildroot}'/*

%check
make test

%generate_compatibility_deps

%files
%dir %{abidir}
%doc ex/perl_dbi_nulls_test.pl ex/profile.pl
%{_bindir}/dbipro*
%{_bindir}/dbilogstrip
%{abidir}/dbilogstrip-option.list
%{perl_vendorarch}/*.p*
%{perl_vendorarch}/DBD/
%{perl_vendorarch}/DBI/
%{perl_vendorarch}/auto/DBI/
%{abidir}/DBI.dump
%{_mandir}/man1/*.1*
%{_mandir}/man3/*.3*

%files doc
%doc README.md

%changelog
* Sat Apr 15 2023 yuanhui <yuanhui@linux.alibaba.com> - 1.643-4
- Optimize the spec file

* Tue Feb 07 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1.643-3
- rebuild with perl_bootstrap disabled

* Mon Jan 30 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1.643-2
- rebuild with perl 5.36.0

* Thu Sep 15 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 1.643-1
- Init from upstream version 1.643
